// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "fragmentVersionSimple.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"

varying vec4 color;
varying highp vec3 p;
varying vec4 cc;

#include "fragmentVersionSimple.h"
uniform highp float TOTAL_REAL_WORLD_TIME;
#define time TOTAL_REAL_WORLD_TIME
#define saturate(x) clamp(x, 0.0, 1.0)

highp float hash(highp float n ){
    return fract( sin(n) * 5182.4193 );}

highp float noise( in highp vec2 x ){
    highp vec2 p = floor(x);
    highp vec2 f = fract(x);
    f = f * f * ( 3.0 - 2.0 * f );
    highp float n = p.x + p.y * 57.0;
    highp float res = mix(mix(mix( hash( n +  0.0), hash( n +  1.0 ), f.x ), mix( hash( n + 57.0 ), hash( n + 58.0 ), f.x ), f.y ),
		    mix(mix( hash(n + 0.0 ) , hash( n + 1.0), f.x ), mix( hash( n + 57.0 ), hash( n + 58.0), f.x ), f.y ), f.y );
    return res;}

highp float fbm(in highp vec2 p){
    highp float res = -0.2397;
    highp float amp = 0.558;
    highp float freq = 2.3;
    p += vec2(0.10,0.4)*time*0.01016;
    for (int i = 0; i < 7; ++i)
    {
        res += amp*noise(freq*p+time*-0.006);
        amp *= 0.5;
        freq *= 2.3;
    }
    return res;
}

#define PI 3.1415926
highp vec3 getColor(highp float c){
   highp float r = cos((c-0.75)*PI);
   highp float g = cos((c-0.55)*PI);
   highp float b = cos((c-0.25)*PI);
   return vec3(r,g,b);}

mat2 rot2D(highp float a){
   highp float c = cos(a);
   highp float s = cos(a);
   return mat2(c,s,-s,c);}

highp float hash1(highp vec2 p){
  highp vec2 v = vec2(PI*1453.0,exp(1.)*3054.0);
  return fract(sin(dot(p,v)*0.1)*4323.0);}

highp vec2 hash2(highp vec2 p){
  highp vec2 v = vec2(hash1(p),hash1(p*p));
  return v+v*rot2D(time*0.5);}

void drawMeteor(inout highp vec3 col, in highp vec2 uv,highp vec2 startP,highp vec2 endP,highp float linWidth){

   uv*=3.0;
   highp vec2 lineDir=endP-startP;
   highp vec2 fragDir=uv-startP;

   highp float lineCoe=clamp(dot(lineDir,fragDir)/dot(lineDir,lineDir),0.,1.0);

   highp vec2 projDir=lineCoe*lineDir;

   highp vec2 fragToLineDir= fragDir- projDir;

   highp float dis=length(fragToLineDir);
   highp float disToTail = length(projDir);
   dis=linWidth/dis;

   col += dis*getColor(0.3)*pow(disToTail,3.0);}

void drawMeteors(inout highp vec3 col,highp vec2 uv){

    highp vec2 dir = normalize(vec2(-1.0,-0.5));
    highp vec2 mv  = -dir*cos(mod(time*1.,PI))*48.0;
    highp vec2 sp  = vec2(10.0+100.0*hash1(vec2(floor(time*4.7/PI))),10.0);
    highp vec2 ep  = sp+dir*5.0;

    drawMeteor(col,uv,sp+mv,ep+mv,0.0005);}

void main(){ 
vec4 sky = cc;
vec4 fc = FOG_COLOR;
vec2 fcc = FOG_CONTROL;
float ty = length(p.xz);

highp float siangd = clamp((sky.b-0.15)*2.0,0.0,1.0);
highp float malamd = clamp(max(1.-fc.b*1.-fc.g,0.0),0.0,1.0);
highp float hujand = smoothstep(0.6, 0.3, fcc.x);
highp float sunsetd = saturate(( fc.r - 0.0) - fc.b);

vec4 ssky = vec4(0.0,0.3,0.58,0.25);
vec4 msky = vec4(0.0,0.2,0.4,0.8);
vec4 hsky = vec4(0.2,0.2,0.2,0.7);
vec4 sunset = vec4(1.5,0.9,0.07,1.0);
   sky = mix(mix(msky,ssky,siangd),hsky,hujand);

vec4 scloud = vec4(1.897);
vec4 mcloud = vec4(0.2,0.3,0.5,0.08)*0.34;
vec4 srcloud = vec4(1.4,0.7,.07,1.5);
vec4 hcloud = vec4(0.3);
 vec4 cloud = mix(mix(mix(mcloud,scloud,siangd),srcloud,sunsetd),hcloud,hujand);

vec4 scs = vec4(0.68);
vec4 scm = vec4(0.27);
vec4 scsr = vec4(0.065);
vec4 sch =  vec4(0.18);
   vec4 shac = mix(mix(mix(scm,scs,siangd),scsr,sunsetd),sch,hujand);

highp float cl = fbm(p.xz*3.5);
highp float den = smoothstep(0.0,0.5,cl);
highp float a = cl-(1.17-den);if(a<0.0)
a = 0.0;cl = 1.2-pow(0.042,a);

highp float sc = fbm(p.xz*3.55);
highp float sd = smoothstep(0.0,0.5,sc);
highp float e = sc-(1.17-sd);if(e<0.0)
e = 0.0;sc = 1.2-pow(0.042,e);

vec3 meteor;
vec2 cuv = p.xz - vec2(0.5);

cuv*=10.;
drawMeteors(meteor,cuv);

if(malamd >.0 && hujand < .2){
   sky.rgb += meteor*malamd;}

sky.rgb += ty*0.9;
sky = mix(mix(sky,cloud,cl),shac,sc);

gl_FragColor = mix(sky,fc,color)+vec4(1.0)*0.001;
gl_FragColor.a = 0.4719;
}